#ifndef A_LIST_SURPLUS_MOVES_H
#define A_LIST_SURPLUS_MOVES_H


#include "a_Structure.h"
#include "a_List_surplus_moves_const.h"
#include "a_Chess_bitboard.h"

// a_List_surplus_moves_generator.cpp
#define TEST_B 0   // -(1-0)      
#define KONTROL_B 0 // -(1-0)   

//---------------------------------------------------------------------------
/*
 *    (Brenkman Andrey)
 *   20.11.2010
*/
//---------------------------------------------------------------------------

/*
    90%

 List_surplus_moves
     
     
 :
  
  

*/

//---------------------------------------------------------------------------
//    
class List_surplus_moves 
{
	//         
	friend class Chess_bitboard;

//////////////////////////////////////////////////////////////////////////////////////////
//public:

	__int32 move[MAX_MOVE];
	/*
	    move     ( 27 )
	--3 --      --6 --   --6 --     --6 --  --6 -- 
	              

	//-------------------------------------------------
	  ..   
	--6 -- 
	 

	0 -  
	1 -  
	2 -  
	3 - 
	4 -  
	5 -  
	6 - 

	 move =  
	  move & 63 ( 63  ...000111111)

	//-------------------------------------------------
	--6 --
	 

	0 -  
	1   
	2  
	3   
	4   
	5    

	12 -    
	13 -   
	14 -    
	15 -    

	22 -      
	23 -     
	24 -      
	25 -      
 
	 move = move | (  << 6)
	 (move>>6) & 63

	//-------------------------------------------------
	--6 --
	  (0 -63)
	 move = move | (  << 12)
	 (move>>12) & 63

	//-------------------------------------------------
	--6 --
	  (0 -63)
	 move = move | (  << 18)
	 (move>>18) & 63

	//-------------------------------------------------
	--3 -- 
	 
	0 -  
	1 -  
	2 -  
	3 - 
	4 -  
	5 -  
	6 - 
	 move = move | (  << 24)
	 (move>>24) & 7 ( 7  ...000111)
	*/

	//     
	__int32 sorting_score[MAX_MOVE];

	//         .   
	// (       )
	unsigned __int8 end_captures;

	//       ..  
	unsigned __int8 end_list;


//////////////////////////////////////////////////////////////////////////////////////////
public:

	//    

	// 
	inline __int32 get_move(const unsigned __int16 n)
	{
		return move[n];
	};

	//      
	inline __int32 get_sorting_score(const unsigned __int16 n)
	{
		return sorting_score[n];
	};

	//         .   
	inline unsigned __int8 get_end_captures()
	{
		return end_captures;
	};

	//       ..  
	inline unsigned __int8 get_end_list()
	{
		return end_list;
	};


//////////////////////////////////////////////////////////////////////////////////////////
public:

	//   

	//      
	inline void set_sorting_score(const unsigned __int16 n,__int32 _sorting_score)
	{
		sorting_score[n] = _sorting_score;
	};





//////////////////////////////////////////////////////////////////////////////////////////
public:
//   
// a_List_surplus_moves_generator.cpp

	//---------------------------------------------------------------------------
	//    +   ( )
	void public_generator_captures_white
	(
		const class Chess_bitboard * const p_bitboard//              
	);

	//---------------------------------------------------------------------------
	//     +   ( )
	void public_generator_captures_black
	(
		const class Chess_bitboard * const p_bitboard//  
	);


	//---------------------------------------------------------------------------
	//     
	// (..     +  )( )
	void public_generator_move_white
	(
		const class Chess_bitboard * const p_bitboard//  
	);

	//---------------------------------------------------------------------------
	//     
	// (..     +  )( )
	void public_generator_move_black
	(
		const class Chess_bitboard * const p_bitboard//  
	);

	//              

	//---------------------------------------------------------------------------
	//           
	//  0    
	unsigned __int8 public_king_white_check
	(
		const class Chess_bitboard * const p_bitboard//  
	);

	//---------------------------------------------------------------------------
	//           
	//  0    
	unsigned __int8 public_king_black_check
	(
		const class Chess_bitboard * const p_bitboard//  
	);


//---------------------------------------------------------------------------
//         ,      
//  (bit board) 
#if TEST_B
	void Bitboard_print
	(
		const class Chess_bitboard * const p_bitboard//  
	);
#endif//TEST_B


//////////////////////////////////////////////////////////////////////////////////////////
private:

	//            

	//---------------------------------------------------------------------------
	//           
	//  0    
	inline unsigned __int8 white_check_square
	(
		const unsigned __int8 & sq,//  (0-63) 
		const class Chess_bitboard * const p_bitboard//  
	);

	//---------------------------------------------------------------------------
	//           
	//  0    
	inline unsigned __int8 black_check_square
	(
		const unsigned __int8 & sq,//  (0-63) 
		const class Chess_bitboard * const p_bitboard//  
	);

	//---------------------------------------------------------------------------
	//    -   
	//        ( )
	inline void list_capture_white
	(
		unsigned __int8 name,//   
		unsigned __int8 type_move,//  
		const unsigned __int8 & from,//  
		const unsigned __int8 & to,//  
		unsigned __int8 & count,//    
		const class Chess_bitboard * const p_bitboard//  
	);

	//---------------------------------------------------------------------------
	//    -   
	//        ( )
	inline void list_capture_black
	(
		unsigned __int8 name,//   
		unsigned __int8 type_move,//  
		const unsigned __int8 & from,//  
		const unsigned __int8 & to,//  
		unsigned __int8 & count,//    
		const class Chess_bitboard * const p_bitboard//  
	);

	//---------------------------------------------------------------------------
	//   
	inline void list_record_move
	(
		unsigned __int8 name,//   
		unsigned __int8 type_move,//  
		const unsigned __int8 & from,//  
		const unsigned __int8 & to,//  
		unsigned __int8 & count,//    
		const class Chess_bitboard * const p_bitboard//  
	);

	//---------------------------------------------------------------------------
	//         
	//      
	inline void list_record_special
	(
		unsigned __int8 name,//   
		unsigned __int8 d_m,//  
		unsigned __int8 & p,//    
		const unsigned __int8 & from,//  
		unsigned __int8 to,//  
		unsigned __int8 capture//   
	);

	//---------------------------------------------------------------------------
	//     ,         
	//       
	inline void KONTROL_captures_W
	(
		const class Chess_bitboard * p_bitboard,//  
		const unsigned __int8 * p_from,//   
		const unsigned __int8 * p_to,//   
		const unsigned __int8 * p_p,//    
		unsigned __int8 name_figure//   
	);

	//---------------------------------------------------------------------------
	//     ,         
	//       
	inline void KONTROL_captures_B
	(
		const class Chess_bitboard * p_bitboard,//  
		const unsigned __int8 * p_from,//   
		const unsigned __int8 * p_to,//   
		const unsigned __int8 * p_p,//    
		unsigned __int8 name_figure//   
	);

	//---------------------------------------------------------------------------
	//     ,    
	//    
	inline void KONTROL_move
	(
		const unsigned __int8 * p_from,//   
		const unsigned __int8 * p_to,//   
		const unsigned __int8 * p_p//    
	);

	//---------------------------------------------------------------------------
	//    (..  )
	__inline __int32 bit_scan_forward_win32
	(
		unsigned __int64 analyzed_number//      
	);

	//---------------------------------------------------------------------------
	//    (..  )
	__inline __int32 bit_scan_reverse_win32
	(
		unsigned __int64 analyzed_number//      
	);


//////////////////////////////////////////////////////////////////////////////////////////
public:
//   
// a_List_surplus_moves_sorting.cpp

	//---------------------------------------------------------------------------
	//  
	void sorting_moves();

	//---------------------------------------------------------------------------
	//    
	void sorting_white_moves_root();

	//---------------------------------------------------------------------------
	//    
	void sorting_black_moves_root();

//////////////////////////////////////////////////////////////////////////////////////////
public:
//   
// j_Killer.cpp

	//    !!!!       
	//---------------------------------------------------------------------------
	//     ( start) 
	void public_insert_killer
	(
		const unsigned __int8 depth,//  
		unsigned __int8 start//        
	);

//////////////////////////////////////////////////////////////////////////////////////////
public:
//   
// j_Hash.cpp

	//    !!!!     -  
	//---------------------------------------------------------------------------
	//  -          
	inline void insert_hash_moves
	(
		unsigned __int32 ind,//  - 
		unsigned __int8 depth ,// 
		unsigned __int8  & flag_insert_hash_move//     -     
	);

};

 #endif //A_LIST_SURPLUS_MOVES_H

/*

              &  0 0 1  
                  0 1 1  
                  -----
                  0 0 1 

            |  0 0 1
                  0 1 1
                  -----
                  0 1 1

    ^  0 0 1
               0 1 1
                  -----
                  0 1 0

*/